package lesson06;

import javax.swing.JOptionPane;

public class CircleOrCross {
	public static void main(String[] args) {
		new CircleOrCross().start();
	}

	//盤データ
	//メソッドでなく,ここで変数を宣言すると,この実行クラス内の全てのメソッドで使えるようになります
	//⇒全ての変数をここに書けば,引数とかいらないんじゃね？⇒もちろんできますが,
	//将来的にその考えを定着させるのは非常に危険ですので,どうしても必要な変数だけ,ここで宣言するようにしましょう
	int[][] boardData = new int[3][3];

	
	/**問題④　○×ゲーム
	 * 正直このプログラムはかなり難易度が高いので，プログラミング入門1が終わったらもう一度挑戦してみることをオススメします
	 */
	void start(){
		while(true){
			//自分のターン
			String input = JOptionPane.showInputDialog(drawBoard() + "\n" +
					"あなたの番です\n" +
					"○を入れたい(行，列)を\n" +
					"カンマ区切りで入力してください");
			String[] stringArray = input.split(",");
			if(stringArray.length != 2){	//長さが適切でない場合
				continue;
			}
			//String配列をint型に
			int row;	//行
			int col;	//列
			row = Integer.parseInt(stringArray[0])-1;
			col = Integer.parseInt(stringArray[1])-1;
			if(row < 0 || row > 2 || col < 0 || col > 2){	//行列が配列をはみ出す場合
				continue;
			}
			if(boardData[row][col] != 0){	//既に○×が入っている場合
				continue;
			}
			boardData[row][col] = 1;	//正常な入力なら○を書く
			
			//○が揃ったか
			if(isFinish()){
				JOptionPane.showMessageDialog(null, drawBoard() + "\n" +
						"あなたの勝ちです！！");
				break;
			}
			//引き分けか
			else if(isDraw()){
				break;
			}

			//コンピュータのターン
			while(true){
				int randomRow = (int)(Math.random()*3);
				int randomCol = (int)(Math.random()*3);
				if(boardData[randomRow][randomCol] == 0){
					boardData[randomRow][randomCol] = -1;
					break;
				}
			}
			
			//×が揃ったか
			if(isFinish()){
				JOptionPane.showMessageDialog(null, drawBoard() + "\n" +
				"あなたの負けです・・・");
				break;
			}
			//引き分けか
			else if(isDraw()){
				break;
			}			
		}
	}
	/** 盤を文字列として返す **/
	String drawBoard(){
		String result = "";
		for(int row = 0; row < 5; row++){
			for(int col = 0; col < 5; col++){
				//偶数行目
				if(row % 2 == 0){
					//偶数列目
					if(col % 2 == 0){
						if(boardData[row/2][col/2] == 1){
							result += "○";
						}
						else if(boardData[row/2][col/2] == -1){
							result += " × ";
						}
						else{
							result += "　";							
						}
					}
					//奇数列目
					else{
						result += "｜";
					}
				}
				//奇数行目
				else{
					//偶数列目
					if(col % 2 == 0){
						result += "－";
					}
					//奇数列目
					else{
						result += "＋";
					}
				}
				
				//最後の列なら改行
				if(col == 4){
					result += "\n";
				}
			}
		}
		return result;
	}
	/** 縦横斜めを見て○か×が揃っていればtrueを返す **/
	boolean isFinish(){
		//行列を見る
		for(int k = 0; k < 3; k++){
			//行が揃った場合
			if(boardData[k][0] == boardData[k][1] && boardData[k][0] == boardData[k][2]){
				if(boardData[k][0] != 0){
					return true;
				}
			}
			//列が揃った場合
			if(boardData[0][k] == boardData[1][k] && boardData[0][k] == boardData[2][k]){
				if(boardData[0][k] != 0){
					return true;
				}
			}
		}
		//斜めを見る
		if(boardData[0][0] == boardData[1][1] && boardData[0][0] == boardData[2][2]){
			if(boardData[1][1] != 0){
				return true;
			}
		}
		else if(boardData[0][2] == boardData[1][1] && boardData[0][2] == boardData[2][0]){
			if(boardData[1][1] != 0){
				return true;
			}
		}
		
		//他のすべての場合，false
		return false;
	}
	
	/** 全てのマスが埋まっていればtrue **/
	boolean isDraw() {
		//引き分け判定
		for(int row = 0; row < 3; row++){
			for(int col = 0; col < 3; col++){
				//0が1個でもあった場合，まだ終わっていない
				if(boardData[row][col] == 0){
					return false;
				}
			}			
		}
		//0が1個もない場合，trueが変える
		JOptionPane.showMessageDialog(null, drawBoard() + "\n" +
				"引き分けです。");
		return true;
	}
}
