package lesson06;

import javax.swing.JOptionPane;

public class ShowBestStudent {
	public static void main(String[] args) {
		new ShowBestStudent().start();
	}
	/* 問題② */
	void start() {
		/* Studentクラスの変数を入れる，3つの箱を用意 */
		Student[] students = new Student[3];
		// 配列の要素を初期化
		initialize(students);
		//一度情報を表示します
		JOptionPane.showMessageDialog(null, getList(students) + "\n"
				+ "最優秀生徒を発表します");
		//変数bestStudentに，getBestStudent(students)メソッドで返ってきたStudentを代入します
		Student bestStudent = getBestStudent(students);

		JOptionPane.showMessageDialog(null, getList(students) + "\n" + "最優秀生徒は"
				+ bestStudent.name + "です");
	}

	/**
	 * 配列の要素を初期化
	 * 
	 * @param students
	 */
	void initialize(Student[] students) {
		//配列の箱に新しくStudentクラスの変数を入れるイメージです
		for (int i = 0; i < students.length; i++) {
			students[i] = new Student();
		}
		//3人分のデータを変数に入れます
		students[0].name = "Alice";
		students[0].mathScore = 60;
		students[0].engScore = 70;
		students[1].name = "Bob";
		students[1].mathScore = 90;
		students[1].engScore = 20;
		students[2].name = "Charley";
		students[2].mathScore = 50;
		students[2].engScore = 100;
	}

	/**
	 * 配列の要素が持つフィールドを列挙して一つの文字列に
	 * 
	 * @param students
	 * @return
	 */
	String getList(Student[] students) {
		/*名前+数学の点数+英語の点数(改行)
		 *を3人分文字列に入れます
		 */
		String result = "(氏名)： (数学)，(英語)\n";
		for (int i = 0; i < students.length; i++) {
			result += students[i].name + ": " + students[i].mathScore + "，"
					+ students[i].engScore + "\n";
		}

		return result;
	}

	/**
	 * 得点の合計が最高の生徒を返す
	 * 
	 * @param students
	 * @return
	 */
	Student getBestStudent(Student[] students) {
		//とりあえず0番目つまり最初の生徒の合計点を一番高いとする
		int bestIndex = 0;
		int bestSumScore = students[0].mathScore + students[0].engScore;

		// 最初の要素を除いて繰り返し比較
		//bestSumScoreより合計点が高い生徒がいれば，その生徒のインデックス(配列番号)と，その合計点を代入する
		for (int i = 1; i < students.length; i++) {
			if (bestSumScore < (students[i].mathScore + students[i].engScore)) {
				bestIndex = i;
				bestSumScore = students[i].mathScore + students[i].engScore;
			}
		}
		//最後にreturnする生徒は一番合計点が高い生徒
		return students[bestIndex];
	}
}

/**
 * 生徒を表すStudentクラス
 */
class Student {
	String name;
	int mathScore;
	int engScore;
}
